#include "ECDSAManager.h"

CECDSAManager::CECDSAManager(void)
{
}

CECDSAManager::~CECDSAManager(void)
{
}

//ڶȡָļݣڲڴⲿͷ
int CECDSAManager::ReadFileECC(const char *szFilePath,char **pDataBuffer,int *pFilelen)
{
	int ret = 0;
	FILE *file = NULL; 
	int nFilelen = 0;
	char *pDataFileBuffer = NULL;
	do 
	{
		file = fopen(szFilePath,"rb");
		if (!file)
		{
			printf("fopenļ%sʧ,%s %s,%d\n",szFilePath,__FILE__,__FUNCTION__ ,__LINE__);
			ret = -1;
			break;
		}

		fseek(file,0L,SEEK_END); /* λļĩβ */
		nFilelen = ftell(file);  // ļ
		pDataFileBuffer = (char*)malloc(nFilelen);
		if (pDataFileBuffer)
		{
			memset(pDataFileBuffer,0,nFilelen);
			fseek(file,0L,SEEK_SET); /* λļͷ */
			fread(pDataFileBuffer,nFilelen,1,file);
			*pDataBuffer = pDataFileBuffer;
			*pFilelen = nFilelen;
			fclose(file);
			file = NULL;
			return ECDSA_SUCESS;
		}
		else
		{
			printf("ڴʧ,%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__);
			ret = -2;
			break;
		}
	} while (0);

	if (file)
	{
		fclose(file);
		file = NULL;
	}

	if (pDataFileBuffer)
	{
		free(pDataFileBuffer);
	}

	*pFilelen = 0;
	*pDataBuffer = NULL;
	return ret;
}

int  CECDSAManager::WritePublicKeyToFile(const char *Path, EC_KEY *pKey)
{
	int nRet = 0;
	BIO *pBioFile = BIO_new_file(Path, "wb+");

	do 
	{
		if (!pBioFile)
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		if (1 != PEM_write_bio_EC_PUBKEY(pBioFile, pKey))
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		nRet = ECDSA_SUCESS;
	} while (0);

	BIO_free(pBioFile); 
	return nRet;
}

int  CECDSAManager::WritePrivateKeyToFile(const char *Path, EC_KEY *pKey,EC_GROUP *ec_group)
{
	int nRet = 0;
	BIO *pBioFile = BIO_new_file(Path, "wb+");

	do 
	{
		if (!pBioFile)
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		PEM_write_bio_ECPKParameters(pBioFile, ec_group);
		if (1 != PEM_write_bio_ECPrivateKey(pBioFile, pKey,NULL,NULL,0,NULL,NULL))
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}
		nRet = ECDSA_SUCESS;
	} while (0);

	BIO_free(pBioFile); 
	return nRet;
}

int CECDSAManager::CreateECDSAKey(const char *pFilePath)
{
	int ret = 0;
	EC_KEY  *ec_key = NULL;;   
	char    *pFileAllPath = NULL;
	do 
	{
		EC_GROUP *ec_group;  
		ec_key = EC_KEY_new();

		if (!ec_key)  
		{ 
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__);  
			break;  
		}   

		ec_group = EC_GROUP_new_by_curve_name(NID_secp256k1);
		if (!ec_group)
		{   
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		EC_GROUP_set_asn1_flag(ec_group, OPENSSL_EC_NAMED_CURVE);
		EC_GROUP_set_point_conversion_form(ec_group, POINT_CONVERSION_UNCOMPRESSED);

		if(1 != EC_KEY_set_group(ec_key,ec_group))  
		{   
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__);  
			break;
		}

		if (!EC_KEY_generate_key(ec_key))
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		char *pPublicKey  = "public.pem";
		char *pPrivateKey = "ec_key.pem";
		int nPathLen = strlen(pFilePath) + strlen(pPublicKey)+ strlen(pPrivateKey)+2;
		pFileAllPath = (char*)malloc(nPathLen);
		//////////////////////////////////////////////////////////////////////////
		//湫Կ
		//ɱ湫Կļ·
		memset((void*)pFileAllPath,0,nPathLen);
		strcpy(pFileAllPath,pFilePath);
		strcat(pFileAllPath,"\\");
		strcat(pFileAllPath,pPublicKey);
		int nWritePublicKeyRet = WritePublicKeyToFile(pFileAllPath,ec_key);

		//////////////////////////////////////////////////////////////////////////
		//˽Կ
		//ɱ˽Կļ·
		memset((void*)pFileAllPath,0,nPathLen);
		strcpy(pFileAllPath,pFilePath);
		strcat(pFileAllPath,"\\");
		strcat(pFileAllPath,pPrivateKey);
		int nWritePrivateKeyRet = WritePrivateKeyToFile(pFileAllPath,ec_key,ec_group);
		ret = nWritePrivateKeyRet + nWritePublicKeyRet==2?ECDSA_SUCESS:0;
	} while (0);

	if (ec_key)
	{
		EC_KEY_free(ec_key);
		ec_key = NULL;
	}

	if (pFileAllPath)
	{
		free(pFileAllPath);
		pFileAllPath = NULL;
	}

	return ret;
}

int CECDSAManager::ECDSASignToBuffer(const char *szPrivateKeyPath,char *szBufferData,const int nBufferData,const char *szLicenceBuffer,unsigned int *pLicencelen)
{
	int ret = 0;
	EC_KEY *ec_key = NULL; 
	BIO    *pBioKeyFile = NULL;

	do 
	{
		if (!szBufferData || !szLicenceBuffer || !pLicencelen)
		{
			printf("Error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		pBioKeyFile = BIO_new_file(szPrivateKeyPath,"rb");
		ec_key = PEM_read_bio_ECPrivateKey(pBioKeyFile, NULL, NULL,NULL);

		if (!ec_key)
		{
			printf("ļ%sжȡԿʧܣ%s %s,%d\n",szPrivateKeyPath,__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		unsigned char *signature = NULL;
		unsigned char digest[32] = {};
		unsigned int dgst_len = 0;

		EVP_MD_CTX md_ctx;
		EVP_MD_CTX_init(&md_ctx);
		EVP_DigestInit(&md_ctx,EVP_sha256());
		EVP_DigestUpdate(&md_ctx, (const void*)szBufferData,nBufferData);
		EVP_DigestFinal(&md_ctx, digest, &dgst_len);

		/* ǩ */   
		if (!ECDSA_sign(0,(const unsigned char *)digest, dgst_len,(unsigned char *)szLicenceBuffer,pLicencelen,ec_key)) 
		{
			printf("ECDSA_sign error%s %s,%d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		ret = ECDSA_SUCESS;
	} while (0);

	if (pBioKeyFile)
	{
		BIO_free(pBioKeyFile);
		pBioKeyFile = NULL;
	}

	if (ec_key)
	{
		EC_KEY_free(ec_key);
		ec_key = NULL;
	}

	return ret;
}

int CECDSAManager::ECDSASignFileToLicenceFile(const char *szPrivateKeyPath,const char *szDataFilePath,const char *szLicencePath)
{
	int nRet = 0;
	FILE *file = NULL;
	char *szDataFile = NULL;
	unsigned int nLicencelen   = 0;
	char szLicenceBuffer[1024] = {};

	do 
	{
		int nFileLen;
		if (1 != ReadFileECC(szDataFilePath,&szDataFile,&nFileLen))
		{
			printf("ļ%sʧܣ%s %s,%d\n",szDataFilePath,__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		nRet = ECDSASignToBuffer(szPrivateKeyPath,szDataFile,nFileLen,szLicenceBuffer,&nLicencelen);
		if (ECDSA_SUCESS == nRet)
		{
			file = fopen(szLicencePath,"wb");
			fwrite(szLicenceBuffer,nLicencelen,1,file);
		}
	} while (0);

	if (file)
	{
		fclose(file);
		file = NULL;
	}

	if (szDataFile)
	{
		free(szDataFile);
		szDataFile = NULL;
	}

	return nRet;
}

int CECDSAManager::ECDSAVerifyLicenceBuffer(const char *szPublicKeyPath,char *szBuffer,int nBufflen,char *szLicenceData,int nLicencelen)
{
	int ret = -1;  
	EC_KEY *ec_key = NULL;  
	EC_GROUP *ec_group = NULL;   
	BIO *pBioKeyFile = NULL;
	do 
	{
		pBioKeyFile = BIO_new_file(szPublicKeyPath,"rb");
		ec_key = PEM_read_bio_EC_PUBKEY(pBioKeyFile, NULL, NULL,NULL);

		if (ec_key == NULL)
		{
			printf("Error%s %s %d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		unsigned char digest[32]={};  
		unsigned int  dgst_len = 0;   
		EVP_MD_CTX md_ctx;  
		EVP_MD_CTX_init(&md_ctx);  
		EVP_DigestInit(&md_ctx, EVP_sha256()); 
		// ɢ㷨  
		EVP_DigestUpdate(&md_ctx, (const void*)szBuffer,nBufflen);  
		EVP_DigestFinal(&md_ctx, digest, &dgst_len);

		/* ֤ǩ */
		nLicencelen++;
		ret = ECDSA_verify(0,(const unsigned char*)digest, dgst_len, (const unsigned char *)szLicenceData, nLicencelen,ec_key);
	} while (0);

	if (ec_key)
	{
		EC_KEY_free(ec_key); 
		ec_key = NULL;
	}

	if (pBioKeyFile)
	{
		BIO_free(pBioKeyFile);
		pBioKeyFile = NULL;
	}

	return ret; 
}

int CECDSAManager::ECDSAVerifyLicenceFile(const char *szPublicKeyPath,const char *szDataFilePath,const char *szLicencePath)
{
	int ret = -1;
	char *pDataFileBuffer  = NULL;
	char *szLicenceBuffer  = NULL;

	do 
	{
		int nDataFilelen  = 0;
		int nLicencelen   = 0;
		if (ECDSA_SUCESS != ReadFileECC(szDataFilePath,&pDataFileBuffer,&nDataFilelen))
		{
			printf("Error%s %s %d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}

		if (ECDSA_SUCESS != ReadFileECC(szLicencePath,&szLicenceBuffer,&nLicencelen))
		{
			printf("Error%s %s %d\n",__FILE__,__FUNCTION__ ,__LINE__); 
			break;
		}
		ret = ECDSAVerifyLicenceBuffer(szPublicKeyPath,pDataFileBuffer,nDataFilelen,szLicenceBuffer,nLicencelen);
	} while (0);

	if (pDataFileBuffer)
	{
		free(pDataFileBuffer);
		pDataFileBuffer = NULL;
	}

	if (szLicenceBuffer)
	{
		free(szLicenceBuffer);
		szLicenceBuffer = NULL;
	}

	return ret;
}