#pragma once
#include <stdio.h>
#include <string.h>

extern "C"{
#include <openssl/ecdh.h>
#include <openssl/evp.h>
#include <openssl/ecdsa.h>
#include <openssl/bio.h>
#include <openssl/err.h>
#include <openssl/ec.h>
#include <openssl/pem.h>
}

#ifdef _WIN32
#pragma comment(lib, "libeay32.lib") 
//#pragma comment(lib, "ssleay32.lib") 
#endif

#define ECDSA_SUCESS 1

class CECDSAManager
{
public:
	CECDSAManager(void);
	~CECDSAManager(void);

	int CreateECDSAKey(const char *pFilePath);

	int ECDSASignFileToLicenceFile(const char *szPrivateKeyPath,const char *szDataFilePath,const char *szLicencePath);
	int ECDSASignToBuffer(const char *szPrivateKeyPath,char *szBufferData,const int nBufferData,const char *szLicenceBuffer,unsigned int *pLicencelen);

	int ECDSAVerifyLicenceBuffer(const char *szPublicKeyPath,char *szBuffer,int nBufflen,char *szLicenceData,int nLicencelen);
	int ECDSAVerifyLicenceFile(const char *szPublicKeyPath,const char *szDataFilePath,const char *szLicencePath);
private:
	int WritePublicKeyToFile(const char *Path, EC_KEY *pKey);
	int WritePrivateKeyToFile(const char *Path, EC_KEY *pKey,EC_GROUP *ec_group);
	int ReadFileECC(const char *szFilePath,char **pDataBuffer,int *pFilelen);
};

